// Repaesentiert eine Population (von Individuen)
// mit den zugehoerigen Funktionen (Selektion, Mutation, Crossover)

   package ga;

   import java.util.Vector;


   public class Population
   {
      // Vector von Individuen
      Vector individuen;
      int sum = 0 ;
   
   
   // Konstruktor: legt einen Vector an	
      public Population()
      {
         individuen = new Vector();
      
      
      }
   
   
     
   // Berechnet die Summe der Fitnesswerte aller Individuen	
      public void berechne_summe()
      {
         sum = 0;
         int i;
      
         i=0;
      
      
         while (this.ausgeben(i) != null) {
            sum += this.ausgeben(i).ausgabe_fitness();
            i++;    	
         }
      
         //System.out.println("Summe: " + sum);
      
      }   
   
   
   //hinzufuegen eines Individuums ans Ende der Liste
      public void hinzufuegen(Individuum neu) {
         individuen.addElement(neu);
      }
   
    //ausgabe eines Individuums an der Stelle Position
      public Individuum ausgeben(int position) {
         if (position >= (individuen.size()))
         {
            return null;}//ausnahmebehandlung!!!!!!!
         else        
            return (Individuum) individuen.elementAt(position);
      }
   
   
   // Selektiert ein Individuum aus der Population.
   // Zugrundeliegender Algorthmus ist Standard Roulette-Wheel-Selektion
      public Individuum selektiere()
      {
         int i;
      // Zufallssumme
         double r = GA.next_double() * sum;
      // Teilsumme
         double partsum = 0.0;
      
         i=0;
         while ((this.ausgeben(i) != null) && (partsum < r)) {
            partsum += this.ausgeben(i).ausgabe_fitness();
            i++;
         }
      
         if (i == 0)
         	i=1;
         	
         //System.out.println("Selektiert: " + (i-1));
      
         return this.ausgeben(i-1);
      
      }
   
    // Anzahl der Individuen
    public int size(){

	return individuen.size();      	
	}   

    
    // Durchschnittliche Fitness der Individuen
    public int durchschnitt(){
	
	if (sum == 0)
		berechne_summe();
	
	if (individuen.size() != 0)
		return sum/individuen.size();      	
    else return -1;
    }   
   
}   


